OGRE: Ogre::GLSLESProgramPipeline Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::GLSLESProgramPipeline Class Reference

Specialisation of GLSLESProgramCommon to provide support for separable programs via the Open GL program pipeline. More...

`#include <OgreGLSLESProgramPipeline.h>`

Inheritance diagram for Ogre::GLSLESProgramPipeline:
[legend]

## Public Member Functions
| GLSLESProgramPipeline (GLSLESShader *vertexProgram, GLSLESShader *fragmentProgram)
| Constructor should only be used by GLSLESProgramPipelineManager. More...
virtual | ~GLSLESProgramPipeline ()
void | activate (void)
| Makes a program pipeline object active by making sure it is linked and then putting it in use. More...
virtual void | extractLayoutQualifiers (void)
| Finds layout qualifiers in the shader source and sets attribute indices appropriately. More...
GLint | getAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the index of a non-standard attribute bound in the linked code. More...
GLint | getBaseInstanceLocation () const
GLSLESShader * | getFragmentShader () const
GLuint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLuint | getGLProgramPipelineHandle () const
| GL Program Pipeline Handle. More...
GLSLESShader * | getVertexShader () const
bool | isAttributeValid (VertexElementSemantic semantic, uint index)
| Is a non-standard attribute bound in the linked code? More...
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)
| Updates program pipeline object uniforms using data from pass iteration GpuProgramParameters. More...
void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniform blocks using shared parameter data from GpuProgramParameters. More...
void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program pipeline object uniforms using named and indexed parameter data from GpuProgramParameters. More...

## Detailed Description

Specialisation of GLSLESProgramCommon to provide support for separable programs via the Open GL program pipeline.

Separable programs consist of shader objects which have been individually linked. This allows for invidual shaders in a program pipeline to be swapped without recompiling the program object, as would be necessary with monolithic programs. This is especially useful in the common case of only entities which change only a few of the shaders in the pipeline while leaving the rest the same.

Remarks
  GLSL ES has no target assembler or entry point specification like DirectX 9 HLSL. Vertex and Fragment shaders only have one entry point called "main". When a shader is compiled, microcode is generated but can not be accessed by the application.

GLSL ES also does not provide assembler low level output after compiling. The GL ES Render system assumes that the Gpu program is a GL Gpu program so GLSLESProgramPipeline will create a GLSLESShader for the low level implementation. The GLES2Program class will create a shader and program object and compile the source but will not create a pipeline object. It's up to GLES2GpuProgram class to request a program pipeline object to link the program object to.

Note
  GLSL ES supports multiple modular shader objects that can be attached to one program object to form a single shader. This is supported through the "attach" material script command. All the modules to be attached are listed on the same line as the attach command separated by white space.

## Constructor & Destructor Documentation

## ◆ GLSLESProgramPipeline()

Ogre::GLSLESProgramPipeline::GLSLESProgramPipeline | ( | GLSLESShader * | vertexProgram,
|  | GLSLESShader * | fragmentProgram
| ) |  |

Constructor should only be used by GLSLESProgramPipelineManager.

## ◆ ~GLSLESProgramPipeline()

virtual Ogre::GLSLESProgramPipeline::~GLSLESProgramPipeline | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ activate()

void Ogre::GLSLESProgramPipeline::activate | ( | void |  | ) |
| virtual

Makes a program pipeline object active by making sure it is linked and then putting it in use.

Implements Ogre::GLSLESProgramCommon.

## ◆ extractLayoutQualifiers()

virtual void Ogre::GLSLESProgramCommon::extractLayoutQualifiers | ( | void |  | ) |
| virtualinherited

Finds layout qualifiers in the shader source and sets attribute indices appropriately.

## ◆ getAttributeIndex()

GLint Ogre::GLSLESProgramPipeline::getAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| virtual

Get the index of a non-standard attribute bound in the linked code.

Reimplemented from Ogre::GLSLESProgramCommon.

## ◆ getBaseInstanceLocation()

GLint Ogre::GLSLESProgramCommon::getBaseInstanceLocation | ( |  | ) | const
| inlineinherited

## ◆ getFragmentShader()

GLSLESShader* Ogre::GLSLESProgramCommon::getFragmentShader | ( |  | ) | const
| inlineinherited

## ◆ getGLProgramHandle()

GLuint Ogre::GLSLESProgramCommon::getGLProgramHandle | ( | void |  | ) | const
| inlineinherited

Get the GL Handle for the program object.

## ◆ getGLProgramPipelineHandle()

GLuint Ogre::GLSLESProgramPipeline::getGLProgramPipelineHandle | ( |  | ) | const
| inline

GL Program Pipeline Handle.

## ◆ getVertexShader()

GLSLESShader* Ogre::GLSLESProgramCommon::getVertexShader | ( |  | ) | const
| inlineinherited

## ◆ isAttributeValid()

bool Ogre::GLSLESProgramCommon::isAttributeValid | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| inherited

Is a non-standard attribute bound in the linked code?

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLESProgramCommon::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inlineinherited

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLESProgramCommon::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inlineinherited

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ updatePassIterationUniforms()

void Ogre::GLSLESProgramPipeline::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| virtual

Updates program pipeline object uniforms using data from pass iteration GpuProgramParameters.

Normally called by GLSLESShader::bindMultiPassParameters() just before multi pass rendering occurs.

Implements Ogre::GLSLESProgramCommon.

## ◆ updateUniformBlocks()

void Ogre::GLSLESProgramPipeline::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniform blocks using shared parameter data from GpuProgramParameters.

Normally called by GLSLESShader::bindParameters() just before rendering occurs.

Implements Ogre::GLSLESProgramCommon.

## ◆ updateUniforms()

void Ogre::GLSLESProgramPipeline::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program pipeline object uniforms using named and indexed parameter data from GpuProgramParameters.

normally called by GLSLESShader::bindParameters() just before rendering occurs.

Implements Ogre::GLSLESProgramCommon.

The documentation for this class was generated from the following file:

- OgreGLSLESProgramPipeline.h